---
title: Object.create()
slug: Web/JavaScript/Reference/Global_Objects/Object/create
tags:
  - ECMAScript 5
  - JavaScript
  - Method
  - 'Null'
  - Object
  - Reference
  - polyfill
---
<p>{{JSRef}}</p>

<p>The <code><strong>Object.create()</strong></code> method creates a new object, using an existing object as the prototype of the newly created object.</p>

<div>{{EmbedInteractiveExample("pages/js/object-create.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Object.create(<var>proto</var>, [<var>propertiesObject</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>proto</var></code></dt>
 <dd>The object which should be the prototype of the newly-created object.</dd>
 <dt><code><var>propertiesObject</var></code> {{Optional_inline}}</dt>
 <dd>If specified and not {{jsxref("undefined")}}, an object whose enumerable own properties (that is, those properties defined upon itself and <em>not</em> enumerable properties along its prototype chain) specify property descriptors to be added to the newly-created object, with the corresponding property names. These properties correspond to the second argument of {{jsxref("Object.defineProperties()")}}.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new object with the specified prototype object and properties.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>The <code><var>proto</var></code> parameter has to be either</p>

<ul>
 <li>{{jsxref("null")}} or</li>
 <li>an {{jsxref("Object")}} excluding <a href="/en-US/docs/Glossary/Primitive#Primitive_wrapper_objects_in_JavaScript">primitive wrapper objects</a>.</li>
</ul>

<p>If <code>proto</code> is neither of these a {{jsxref("TypeError")}} is thrown.</p>

<h2 id="Custom_and_Null_objects">Custom and Null objects</h2>

<p>A new object created from a completely custom object (especially one created from the <code>null</code> object, which is basically a custom object with NO members) can behave in unexpected ways. This is especially true when debugging, since common object-property converting/detecting utility functions may generate errors, or lose information (especially if using silent error-traps that ignore errors). For example, here are two objects:</p>

<pre class="brush: js notranslate">oco = Object.create( {} );   // create a normal object
ocn = Object.create( null ); // create a "null" object

&gt; console.log(oco) // {} -- Seems normal
&gt; console.log(ocn) // {} -- Seems normal here too, so far

oco.p = 1; // create a simple property on normal obj
ocn.p = 0; // create a simple property on "null" obj

&gt; console.log(oco) // {p: 1} -- Still seems normal
&gt; console.log(ocn) // {p: 0} -- Still seems normal here too. BUT WAIT...
</pre>

<p>As shown above, all seems normal so far. However, when attempting to actually use these objects, their differences quickly become apparent:</p>

<pre class="brush: js notranslate">&gt; "oco is: " + oco // shows "oco is: [object Object]"

&gt; "ocn is: " + ocn // throws error: Cannot convert object to primitive value
</pre>

<p>Testing just a few of the many most basic built-in functions shows the magnitude of the problem more clearly:</p>

<pre class="brush: js notranslate">&gt; alert(oco) // shows [object Object]
&gt; alert(ocn) // throws error: Cannot convert object to primitive value

&gt; oco.toString() // shows [object Object]
&gt; ocn.toString() // throws error: ocn.toString is not a function

&gt; oco.valueOf() // shows {}
&gt; ocn.valueOf() // throws error: ocn.valueOf is not a function

&gt; oco.hasOwnProperty("p") // shows "true"
&gt; ocn.hasOwnProperty("p") // throws error: ocn.hasOwnProperty is not a function

&gt; oco.constructor // shows "Object() { [native code] }"
&gt; ocn.constructor // shows "undefined"
</pre>

<p>As said, these differences can make debugging even simple-seeming problems quickly go astray. For example:</p>

<p><em>A simple common debugging function:</em></p>

<pre class="brush: js notranslate">// display top-level property name:value pairs of given object
function ShowProperties(obj){
  for(var prop in obj){
    console.log(prop + ": " + obj[prop] + "\n" );
  }
}</pre>

<p><em>Not such simple results: (especially if silent error-trapping had hidden the error messages)</em></p>

<pre class="brush: js notranslate">ob={}; ob.po=oco; ob.pn=ocn; // create a compound object using the test objects from above as property values

&gt; ShowProperties( ob ) // display top-level properties
- po: [object Object]
- Error: Cannot convert object to primitive value

Note that only first property gets shown.
</pre>

<p><em>(But if the same object is created in a different order -- at least in some implementations...)</em></p>

<pre class="brush: js notranslate">ob={}; ob.pn=ocn; ob.po=oco; // create same compound object again, but create same properties in different order

&gt; ShowProperties( ob ) // display top-level properties
- Error: Cannot convert object to primitive value

Note that neither property gets shown.</pre>

<p>Note that such a different order may arise statically via disparate fixed codings such as here, but also dynamically via whatever the order any such property-adding code-branches actually get executed at runtime as depends on inputs and/or random-variables. Then again, the actual iteration order is not guaranteed no matter what the order members are added.</p>

<p>Be aware of, also, that using Object.entries() on an object created via Object.create() will result in an empty array being returned.</p>

<pre class="brush: js notranslate">var obj = Object.create({ a: 1, b: 2 });

&gt; console.log(Object.entries(obj)); // shows "[]"
</pre>

<h4 id="Some_NON-solutions">Some NON-solutions</h4>

<p>A good solution for the missing object-methods is not immediately apparent.</p>

<p>Adding the missing object-method directly from the standard-object does NOT work:</p>

<pre class="brush: js notranslate">ocn = Object.create( null ); // create "null" object (same as before)

ocn.toString = Object.toString; // since new object lacks method then try assigning it directly from standard-object

<span>&gt; ocn.toString // shows "toString() { [native code] }" -- missing method seems to be there now</span>
&gt; ocn.toString == Object.toString // shows "true" -- method seems to be same as the standard object-method

&gt; ocn.toString() // error: Function.prototype.toString requires that 'this' be a Function
</pre>

<p><br>
 Adding the missing object-method directly to new object's "prototype" does not work either, since the new object does not have a real prototype (which is really the cause of ALL these problems) and one cannot be <strong>directly</strong> added:</p>

<pre class="brush: js notranslate">ocn = Object.create( null ); // create "null" object (same as before)

ocn.prototype.toString = Object.toString; // Error: Cannot set property 'toString' of undefined

ocn.prototype = {};                       // try to create a prototype
ocn.prototype.toString = Object.toString; // since new object lacks method then try assigning it from standard-object  <span>

&gt; ocn.toString() // error: ocn.toString is not a function</span>
</pre>

<p><br>
 Adding the missing object-method by using the standard-object<strong> </strong>as new object's prototype does not work either:</p>

<pre class="brush: js notranslate">ocn = Object.create( null );        // create "null" object (same as before)
Object.setPrototypeOf(ocn, Object); // set new object's prototype to the standard-object

&gt; ocn.toString() // error: Function.prototype.toString requires that 'this' be a Function
</pre>

<h4 id="Some_OK_solutions">Some OK solutions</h4>

<p>Again, adding the missing object-method directly from the <strong>standard-object </strong>does NOT work. However, adding the <strong>generic</strong> method directly, DOES:</p>

<pre class="brush: js notranslate">ocn = Object.create( null ); // create "null" object (same as before)

ocn.toString = toString; // since new object lacks method then assign it directly from generic version

&gt; ocn.toString() // shows "[object Object]"
&gt; "ocn is: " + ocn // shows "ocn is: [object Object]"

ob={}; ob.pn=ocn; ob.po=oco; // create a compound object (same as before)

&gt; ShowProperties(ob) // display top-level properties
- po: [object Object]
- pn: [object Object]
</pre>

<p>However, setting the generic <strong>prototype</strong> as the new object's prototype works even better:</p>

<pre class="brush: js notranslate">ocn = Object.create( null );                  // create "null" object (same as before)
Object.setPrototypeOf(ocn, Object.prototype); // set new object's prototype to the "generic" object (NOT standard-object)
</pre>

<p><em>(In addition to all the string-related functions shown above, this also adds:)</em></p>

<pre class="brush: js notranslate">&gt; ocn.valueOf() // shows {}
&gt; ocn.hasOwnProperty("x") // shows "false"
&gt; ocn.constructor // shows "Object() { [native code] }"

// ...and all the rest of the properties and methods of Object.prototype.
</pre>

<p>As shown, objects modified this way now look very much like ordinary objects.</p>

<h2 id="Polyfill">Polyfill</h2>

<p>This polyfill covers the main use case, which is creating a new object for which the prototype has been chosen but doesn't take the second argument into account.</p>

<p>Note that while the setting of <code>null</code> as <code>[[Prototype]]</code> is supported in the real ES5 <code>Object.create</code>, this polyfill cannot support it due to a limitation inherent in versions of ECMAScript lower than 5.</p>

<pre class="brush: js notranslate"> if (typeof Object.create !== "function") {
    Object.create = function (proto, propertiesObject) {
        if (typeof proto !== 'object' &amp;&amp; typeof proto !== 'function') {
            throw new TypeError('Object prototype may only be an Object: ' + proto);
        } else if (proto === null) {
            throw new Error("This browser's implementation of Object.create is a shim and doesn't support 'null' as the first argument.");
        }

        if (typeof propertiesObject != 'undefined') {
            throw new Error("This browser's implementation of Object.create is a shim and doesn't support a second argument.");
        }

        function F() {}
        F.prototype = proto;

        return new F();
    };
}
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Classical_inheritance_with_Object.create">Classical inheritance with <code>Object.create()</code></h3>

<p>Below is an example of how to use <code>Object.create()</code> to achieve classical inheritance. This is for a single inheritance, which is all that JavaScript supports.</p>

<pre class="brush: js notranslate">// Shape - superclass
function Shape() {
  this.x = 0;
  this.y = 0;
}

// superclass method
Shape.prototype.move = function(x, y) {
  this.x += x;
  this.y += y;
  console.info('Shape moved.');
};

// Rectangle - subclass
function Rectangle() {
  Shape.call(this); // call super constructor.
}

// subclass extends superclass
Rectangle.prototype = Object.create(Shape.prototype);

//If you don't set Rectangle.prototype.constructor to Rectangle,
//it will take the prototype.constructor of Shape (parent).
//To avoid that, we set the prototype.constructor to Rectangle (child).
Rectangle.prototype.constructor = Rectangle;

var rect = new Rectangle();

console.log('Is rect an instance of Rectangle?', rect instanceof Rectangle); // true
console.log('Is rect an instance of Shape?', rect instanceof Shape); // true
rect.move(1, 1); // Outputs, 'Shape moved.'
</pre>

<p>If you wish to inherit from multiple objects, then mixins are a possibility.</p>

<pre class="brush: js notranslate">function MyClass() {
  SuperClass.call(this);
  OtherSuperClass.call(this);
}

// inherit one class
MyClass.prototype = Object.create(SuperClass.prototype);
// mixin another
Object.assign(MyClass.prototype, OtherSuperClass.prototype);
// re-assign constructor
MyClass.prototype.constructor = MyClass;

MyClass.prototype.myMethod = function() {
  // do something
};
</pre>

<p>{{jsxref("Object.assign()")}} copies properties from the OtherSuperClass prototype to the MyClass prototype, making them available to all instances of MyClass. <code>Object.assign()</code> was introduced with ES2015 and <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/assign#Polyfill">can be polyfilled</a>. If support for older browsers is necessary, <code><a href="https://api.jquery.com/jQuery.extend/">jQuery.extend()</a></code> or <code><a href="https://lodash.com/docs/#assign">_.assign()</a></code> can be used.</p>

<h3 id="Using_propertiesObject_argument_with_Object.create">Using propertiesObject argument with Object.create()</h3>

<pre class="brush: js notranslate">var o;

// create an object with null as prototype
o = Object.create(null);

o = {};
// is equivalent to:
o = Object.create(Object.prototype);

// Example where we create an object with a couple of
// sample properties. (Note that the second parameter
// maps keys to *property descriptors*.)
o = Object.create(Object.prototype, {
  // foo is a regular 'value property'
  foo: {
    writable: true,
    configurable: true,
    value: 'hello'
  },
  // bar is a getter-and-setter (accessor) property
  bar: {
    configurable: false,
    get: function() { return 10; },
    set: function(value) {
      console.log('Setting `o.bar` to', value);
    }
/* with ES2015 Accessors our code can look like this
    get() { return 10; },
    set(value) {
      console.log('Setting `o.bar` to', value);
    } */
  }
});

function Constructor() {}
o = new Constructor();
// is equivalent to:
o = Object.create(Constructor.prototype);
// Of course, if there is actual initialization code
// in the Constructor function,
// the Object.create() cannot reflect it

// Create a new object whose prototype is a new, empty
// object and add a single property 'p', with value 42.
o = Object.create({}, { p: { value: 42 } });

// by default properties ARE NOT writable,
// enumerable or configurable:
o.p = 24;
o.p;
// 42

o.q = 12;
for (var prop in o) {
  console.log(prop);
}
// 'q'

delete o.p;
// false

// to specify an ES3 property
o2 = Object.create({}, {
  p: {
    value: 42,
    writable: true,
    enumerable: true,
    configurable: true
  }
});
/* is not equivalent to:
This will create an object with prototype : {p: 42 }
o2 = Object.create({p: 42}) */
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.create', 'Object.create')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Object.create")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.defineProperty()")}}</li>
 <li>{{jsxref("Object.defineProperties()")}}</li>
 <li>{{jsxref("Object.prototype.isPrototypeOf()")}}</li>
 <li>{{jsxref("Reflect.construct()")}}</li>
 <li>John Resig's post on <a href="http://ejohn.org/blog/objectgetprototypeof/">getPrototypeOf()</a></li>
</ul>
